{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-hic:v42.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 10000000,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-c",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/chunksize"
                },
                {
                    "type": "string",
                    "default": "",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-u",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/custom_res"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/input_cool"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-j",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/juicer_res"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 4,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-p",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/ncores"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-B",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/no_balance"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "out",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-o",
                        "separate": true
                    },
                    "id": "#cool2mcool.cwl/outprefix"
                }
            ],
            "baseCommand": "run-cool2multirescool.sh",
            "id": "#cool2mcool.cwl",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.multires.cool"
                    },
                    "id": "#cool2mcool.cwl/mcool"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-hic:v42.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "separate": true
                    },
                    "id": "#cooler.cwl/binsize"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "separate": true
                    },
                    "id": "#cooler.cwl/chrsizes"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "position": 6,
                        "separate": true
                    },
                    "id": "#cooler.cwl/max_split"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 8,
                    "inputBinding": {
                        "position": 4,
                        "separate": true
                    },
                    "id": "#cooler.cwl/ncores"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "out",
                    "inputBinding": {
                        "position": 5,
                        "separate": true
                    },
                    "id": "#cooler.cwl/outprefix"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "secondaryFiles": [
                        "$(self.basename + '.px2')"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    },
                    "id": "#cooler.cwl/pairs"
                }
            ],
            "baseCommand": "run-cooler.sh",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "*.cool"
                    },
                    "id": "#cooler.cwl/cool"
                }
            ],
            "id": "#cooler.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "fdn_format": "chromsize",
                    "id": "#main/chromsizes"
                },
                {
                    "type": "int",
                    "default": 10000000,
                    "id": "#main/chunksize"
                },
                {
                    "type": "string",
                    "default": "1000,2000,5000,10000,25000,50000,100000,250000,500000,1000000,2500000,5000000,10000000",
                    "id": "#main/custom_res"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "id": "#main/higlass"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "fdn_format": "pairs",
                    "id": "#main/input_pairs"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "id": "#main/juicer_res"
                },
                {
                    "type": "int",
                    "default": 0,
                    "id": "#main/mapqfilter_juicer"
                },
                {
                    "type": "int",
                    "default": 2,
                    "id": "#main/max_split_cooler"
                },
                {
                    "type": "string",
                    "default": "14g",
                    "id": "#main/maxmem"
                },
                {
                    "type": "int",
                    "default": 1000,
                    "id": "#main/min_res"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "id": "#main/no_balance"
                },
                {
                    "type": "int",
                    "default": 13,
                    "id": "#main/nres"
                },
                {
                    "type": "int",
                    "default": 8,
                    "id": "#main/nthreads"
                }
            ],
            "steps": [
                {
                    "run": "#cool2mcool.cwl",
                    "fdn_step_meta": {
                        "software_used": [
                            "cooler_0.7.6"
                        ],
                        "description": "Cooler file is converted to mcool",
                        "analysis_step_types": [
                            "aggregation",
                            "file format conversion"
                        ]
                    },
                    "out": [
                        "#main/cool2mcool/mcool"
                    ],
                    "in": [
                        {
                            "source": "#main/chunksize",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cool2mcool/chunksize"
                        },
                        {
                            "source": "#main/custom_res",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cool2mcool/custom_res"
                        },
                        {
                            "fdn_format": "cool",
                            "source": "#main/cooler/cool",
                            "fdn_type": "data file",
                            "fdn_cardinality": "single",
                            "id": "#main/cool2mcool/input_cool"
                        },
                        {
                            "source": "#main/juicer_res",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cool2mcool/juicer_res"
                        },
                        {
                            "source": "#main/nthreads",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cool2mcool/ncores"
                        },
                        {
                            "source": "#main/no_balance",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cool2mcool/no_balance"
                        }
                    ],
                    "id": "#main/cool2mcool"
                },
                {
                    "run": "#cooler.cwl",
                    "fdn_step_meta": {
                        "software_used": [
                            "cooler_0.7.6"
                        ],
                        "description": "Merged Pairs file is processed using Cooler",
                        "analysis_step_types": [
                            "aggregation"
                        ]
                    },
                    "out": [
                        "#main/cooler/cool"
                    ],
                    "in": [
                        {
                            "source": "#main/min_res",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cooler/binsize"
                        },
                        {
                            "fdn_format": "chromsizes",
                            "source": "#main/chromsizes",
                            "fdn_type": "reference file",
                            "fdn_cardinality": "single",
                            "id": "#main/cooler/chrsizes"
                        },
                        {
                            "source": "#main/max_split_cooler",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cooler/max_split"
                        },
                        {
                            "source": "#main/nthreads",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/cooler/ncores"
                        },
                        {
                            "fdn_format": "pairs",
                            "source": "#main/merge-pairs/merged_pairs",
                            "fdn_type": "data file",
                            "fdn_cardinality": "single",
                            "id": "#main/cooler/pairs"
                        }
                    ],
                    "id": "#main/cooler"
                },
                {
                    "run": "#merge-pairs.cwl",
                    "fdn_step_meta": {
                        "software_used": [
                            "pairix_0.3.3"
                        ],
                        "description": "Merging pair files",
                        "analysis_step_types": [
                            "merging"
                        ]
                    },
                    "out": [
                        "#main/merge-pairs/merged_pairs"
                    ],
                    "in": [
                        {
                            "fdn_format": "pairs",
                            "source": "#main/input_pairs",
                            "fdn_type": "data file",
                            "fdn_cardinality": "array",
                            "id": "#main/merge-pairs/input_pairs"
                        }
                    ],
                    "id": "#main/merge-pairs"
                },
                {
                    "run": "#pairs2hic.cwl",
                    "fdn_step_meta": {
                        "software_used": [
                            "juicer_tools_1.8.9-cuda8"
                        ],
                        "description": "Merged Pairs file is processed using Juicebox",
                        "analysis_step_types": [
                            "aggregation"
                        ]
                    },
                    "out": [
                        "#main/pairs2hic/hic"
                    ],
                    "in": [
                        {
                            "fdn_format": "chromsizes",
                            "source": "#main/chromsizes",
                            "fdn_type": "reference file",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/chromsizes"
                        },
                        {
                            "source": "#main/custom_res",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/custom_res"
                        },
                        {
                            "source": "#main/higlass",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/higlass"
                        },
                        {
                            "fdn_format": "pairs",
                            "source": "#main/merge-pairs/merged_pairs",
                            "fdn_type": "data file",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/input_pairs"
                        },
                        {
                            "source": "#main/mapqfilter_juicer",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/mapqfilter"
                        },
                        {
                            "source": "#main/maxmem",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/maxmem"
                        },
                        {
                            "source": "#main/min_res",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/min_res"
                        },
                        {
                            "source": "#main/no_balance",
                            "fdn_type": "parameter",
                            "fdn_cardinality": "single",
                            "id": "#main/pairs2hic/no_balance"
                        }
                    ],
                    "id": "#main/pairs2hic"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "fdn_format": "hic",
                    "fdn_output_type": "processed",
                    "outputSource": "#main/pairs2hic/hic",
                    "id": "#main/hic"
                },
                {
                    "type": "File",
                    "fdn_format": "mcool",
                    "fdn_output_type": "processed",
                    "outputSource": "#main/cool2mcool/mcool",
                    "id": "#main/mcool"
                },
                {
                    "type": "File",
                    "fdn_output_type": "processed",
                    "fdn_format": "pairs",
                    "fdn_secondary_file_formats": [
                        "pairs_px2"
                    ],
                    "outputSource": "#main/merge-pairs/merged_pairs",
                    "id": "#main/merged_pairs"
                }
            ],
            "fdn_meta": {
                "category": "merging + aggregation + normalization",
                "data_types": [
                    "ChIA-PET"
                ],
                "name": "#main/hi-c-processing-pairs-nore-nonorm",
                "title": "Generation of multiresolution Hi-C contact matrices from a set of contact lists, no normalization, no restriction enzyme",
                "doc": "This is a subworkflow of the Hi-C data analysis pipeline for the data generated without restriction enzyme, without matrix normalization. It takes pairs files for all replicates of a sample, merges them and then produces multi-resolution Hi-c matrices for visualization. The pipeline produces 4 output files. 1) Replicated merged pairs file 2) Contact matrices in .hic format 3) Multiresolution mcool file and 4) normalization vector of mcool files for visualization in juicebox.",
                "workflow_type": "Hi-C data analysis"
            },
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-hic:v42.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "inputBinding": {
                        "position": 2,
                        "itemSeparator": " ",
                        "separate": true
                    },
                    "id": "#merge-pairs.cwl/input_pairs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "out",
                    "inputBinding": {
                        "position": 1,
                        "separate": true
                    },
                    "id": "#merge-pairs.cwl/outprefix"
                }
            ],
            "baseCommand": "run-merge-pairs.sh",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".px2"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.outprefix + '.pairs.gz')"
                    },
                    "id": "#merge-pairs.cwl/merged_pairs"
                }
            ],
            "id": "#merge-pairs.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "duplexa/4dn-hic:v42.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-c",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/chromsizes"
                },
                {
                    "type": "string",
                    "default": "",
                    "inputBinding": {
                        "position": 8,
                        "prefix": "-u",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/custom_res"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-g",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/higlass"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/input_pairs"
                },
                {
                    "type": "int",
                    "default": 0,
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-q",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/mapqfilter"
                },
                {
                    "type": "string",
                    "default": "14g",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-m",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/maxmem"
                },
                {
                    "type": "int",
                    "default": 5000,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-r",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/min_res"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 9,
                        "prefix": "-B",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/no_balance"
                },
                {
                    "type": "string",
                    "default": "out",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-o",
                        "separate": true
                    },
                    "id": "#pairs2hic.cwl/output_prefix"
                }
            ],
            "baseCommand": "run-juicebox-pre.sh",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.hic"
                    },
                    "id": "#pairs2hic.cwl/hic"
                }
            ],
            "id": "#pairs2hic.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
